//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property strict
#property script_show_inputs

input int PowerCount = 5;

#include <Arrays\ArrayInt.mqh>
#include <Arrays\ArrayLong.mqh>
#include <Arrays\ArrayFloat.mqh>
#include <Arrays\ArrayDouble.mqh>

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   srand(_RandomSeed);
   int iterations=(int)pow(10,PowerCount);
   CArrayInt      arrI1, arrI2;
   CArrayLong     arrL1, arrL2;
   CArrayFloat    arrF1, arrF2;
   CArrayDouble   arrD1, arrD2;
   
   arrI1.Reserve(iterations);
   arrI2.Reserve(iterations);
   arrL1.Reserve(iterations);
   arrL2.Reserve(iterations);
   arrF1.Reserve(iterations);
   arrF2.Reserve(iterations);
   arrD1.Reserve(iterations);
   arrD2.Reserve(iterations);

   for(int i=0;i<iterations;i++)
   {
      arrI1.Add(rand()%50000);
      arrI2.Add(rand()%50000);
      arrL1.Add((long)arrI1[i]);
      arrL2.Add((long)arrI2[i]);
      arrF1.Add((float)arrI1[i]);
      arrF2.Add((float)arrI2[i]);
      arrD1.Add((double)arrI1[i]);
      arrD2.Add((double)arrI2[i]);
   }

ulong m;
long result, suml;
double sumd;

///TESTING DOUBLE
   result=0;
   sumd=0;
   m=GetMicrosecondCount();
   for(int j=0;j<iterations;j++)
   {
      for(int i=0;i<iterations;i++)
      {
         double v=Add(arrD1[i],arrD2[i]);
         sumd+=v;
         if(v>2000)
            result++;
      }
   }
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("<double>: %lli ms for %li^2 iterations (result = %lli sum=%g)",m,iterations,result,sumd);

///TESTING FLOAT
   result=0;
   sumd=0;
   m=GetMicrosecondCount();
   for(int j=0;j<iterations;j++)
   {
      for(int i=0;i<iterations;i++)
      {
         float v=Add(arrF1[i],arrF2[i]);
         sumd+=v;
         if(v>2000)
            result++;
      }
   }
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("<float>:  %lli ms for %li^2 iterations (result = %lli sum=%g)",m,iterations,result,sumd);///TESTING INT

///TESTING LONG
   result=0;
   suml=0;
   m=GetMicrosecondCount();
   for(int j=0;j<iterations;j++)
   {
      for(int i=0;i<iterations;i++)
      {
         long v=Add(arrL1[i],arrL2[i]);
         suml+=v;
         if(v>2000)
            result++;
      }
   }
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("<long>:   %lli ms for %li^2 iterations (result = %lli sum=%lli)",m,iterations,result,suml);

///TESTING INT
   result=0;
   suml=0;
   m=GetMicrosecondCount();
   for(int j=0;j<iterations;j++)
   {
      for(int i=0;i<iterations;i++)
      {
         int v=Add(arrI1[i],arrI2[i]);
         suml+=v;
         if(v>2000)
            result++;
      }
   }
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("<int>:    %lli ms for %li^2 iterations (result = %lli sum=%lli)",m,iterations,result,suml);

}
//+------------------------------------------------------------------+

template<typename T>
T Add(const T num1, const T num2)
{
   return num1+num2;
}
